#!/usr/bin/python
# encoding: utf-8

''' getUrlsVideos.py

-Fabrique une url de recherche dans youtube
-Télécharge la page de résultat
-Parse la page et liste les URLs finales des videos youtube

'''

import urllib2
import math
import re
from sets import Set

def getUrlsVideos(word, nb_url = 50):
	url_pattern = re.compile('''http://www.youtube.com/watch[^+]*?['"]''') 
	if nb_url > 50 : 
		nb_pages = int(math.ceil(nb_url/50.))
#		print "nombre de pages youtube: "+str(nb_pages)
		searchurls = []
		all_urls = []
		for i in range (0,nb_pages):
			if i==0: # start-index=0 impossible
				searchurls.append("http://gdata.youtube.com/feeds/api/videos?q="+word+"&orderby=published&search_duration=short&max-results=50&start-index=1")
			else:
				start_index= str(51*i)
				searchurls.append("http://gdata.youtube.com/feeds/api/videos?q="+word+"&orderby=published&search_duration=short&max-results=50&start-index="+start_index)
#			print "url "+str(i)+":"+searchurls[i]
			response = urllib2.urlopen(searchurls[i])
			html = response.read()
			tmp_urls = url_pattern.findall(html)
			for index, value in enumerate(tmp_urls):
				tmp_urls[index] =  value.strip('"').strip("&amp;feature=youtube_gdata'")
				all_urls.append(tmp_urls[index])
		return Set(all_urls)
		
	else:		
		searchurl = "http://gdata.youtube.com/feeds/api/videos?q="+word+"&orderby=published&search_duration=short&max-results="+str(nb_url)
		response = urllib2.urlopen(searchurl)
		html = response.read()
		all_urls = url_pattern.findall(html)
		for index, value in enumerate(all_urls):
			all_urls[index] =  value.strip('"').strip("&amp;feature=youtube_gdata'")
		return Set(all_urls)
		#return all_urls

if __name__ == '__main__':
	for i in getUrlsVideos("cow", 10):
		print i
	


