#!/usr/bin/env python
# encoding: utf-8
"""
create_db.py

Created by Alexandre Korber on 2009-10-14.
Copyright (c) 2009 __MyCompanyName__. All rights reserved.
"""

import sys
import os
import sqlite3

def create():
	connection = sqlite3.connect('museur.db')
	c = connection.cursor()
	# Create table
	c.execute('''create table IF NOT EXISTS files (id INTEGER PRIMARY KEY, url TEXT, word TEXT, duration TEXT, played INTEGER)''')
	# Save (commit) the changes
	connection.commit()
	# We can also close the cursor if we are done with it
	c.close()

def insert(url_db,url,word,duration,played):
	connection = sqlite3.connect(url_db)
	# connection.text_factory = sqlite3.OptimizedUnicode
	c = connection.cursor()
	# Create table
	c.execute("INSERT INTO files VALUES (null,?,?,?,?)",(url,word,duration,played))
	# Save (commit) the changes
	connection.commit()
	# We can also close the cursor if we are done with it
	c.close()

def select(word):
	connection = sqlite3.connect('museur.db')
	c = connection.cursor()
	# Create table
	print c.execute("SELECT * FROM files WHERE word=?", (word,)).fetchall()
	# We can also close the cursor if we are done with it
	c.close()




if __name__ == '__main__':
	insert("museur.db","../download/ybztxhncge-.mp4","maest?","0","0")
#	create()	
#	select('antilope')
#	pass
