#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
randomWord.py

Created by Charles Hebert on 2008-06-02 contact: charles.hebert@gmail.com.
Copyright (c) 2008. All rights reserved.
"""

__author__ = 'Charles Hebert (charles.hebert@gmail.com)'
__date__ = '2008-06-02'
__version__ = '1'

import os
import re
import sys
import string
import random
import time

dico_folder = "../"
dictionaries_filenames = ['../dicos/fr.dic','../dicos/en.dic','../dicos/es_ES.dic','../dicos/hi.dic','../dicos/de_DE_frami.dic','../dicos/eu-ES.dic','../dicos/it_IT.dic','../dicos/ca_ES.dic']

def randomWord():
	data_word = []
	for dictionary in dictionaries_filenames:
		handle_in = open(dictionary)
		for line in handle_in:
			w = line[:-1].split("/")[0] # retire le dernier caractère
			data_word.append(w)
		handle_in.close()
	randomword = random.choice(data_word)
	w = string.replace(randomword,"'","")
	return str(w)
	

if __name__ == '__main__':
	print randomWord()



